#ifndef __LIBTL_FORMS_H
#define __LIBTL_FORMS_H

#ifdef NO_FORMS

typedef struct {
	int x,y,w,h;
} FL_OBJECT;

typedef enum
{
    FL_BLACK, FL_RED, FL_GREEN, FL_YELLOW,
    FL_BLUE, FL_MAGENTA, FL_CYAN, FL_WHITE,
} FL_PD_COL;

typedef enum
{
    FL_ALIGN_CENTER,
    FL_ALIGN_TOP = 1,
    FL_ALIGN_BOTTOM = 2,
    FL_ALIGN_LEFT = 4,
    FL_ALIGN_RIGHT = 8,
} FL_ALIGN;

typedef enum
{
    FL_INVALID_STYLE = -1,
    FL_NORMAL_STYLE,
    FL_BOLD_STYLE,
    FL_ITALIC_STYLE,
    FL_BOLDITALIC_STYLE,
} F_TEXT_STYLE;

void fl_activate_all_forms();
void fl_show_messages(const char* text);
void fl_show_message(const char* text, const char* t2, const char* t3);

typedef struct {
	FL_OBJECT*	grafik;
} FD_FORM;

void fl_set_clipping(int x,int y,int w,int h);
void fl_unset_clipping();
void fl_line (int x, int y, int x1, int y1, int c);
void fl_oval (int mode, int x, int y, int r1, int r2, int c);
void fl_drw_text(int pos, int x, int y, int width, int height, int color, int size, int style, const char* text);

#else // use forms.h

#include <forms.h>

/* einige X-Makros: */
#define XFLUSH            XFlush(fl_get_display())
#define CURSOR_WATCH(win) { fl_set_cursor(win,XC_watch); XFLUSH; }
#define CURSOR_NORM(win)  fl_reset_cursor(win)

extern void FinishForm( FL_FORM* theForm );

#endif

#endif // __LIBTL_FORMS_H
