
#include <stdlib.h>
#include <math.h>
#include <forms.h>
#include "libtl/libtl_string.h"
#include "vs_fd.h"
#include "vs_sub.h"
#include "vs_language.h"
#include "vs_file.h"
#include "vs_beob.h"

FD_beob_list  *fd_beob_list;
FD_beob_neu   *fd_beob_neu;
FD_observer   *fd_observer;

const char    INFO_CHR[30] = ":YIMUVWHLSAGJKZO"; 
#define       INFO_MAX     strlen(INFO_CHR)

/****************************************************************************/
/*  Liste der Beobachtungen                                                 */
/****************************************************************************/

struct RHell *beob_neu_work_hellPtr = NULL;
  
void Beob_Liste_Create (FL_OBJECT *obj)
{
	int           i, hell;
	struct RHell *hellPtr;
	char          text[256],tzahl[30];
  
	fl_clear_browser(obj);
	fl_set_browser_fontstyle(obj,FL_MEDIUM_SIZE); 
	hellPtr = hellFirst;
	for (i=0; i<stern.hellZahl; i++) {
		sprintf(text,"@f"); /* @f fixed font width */
		ZeitDatum(hellPtr->datum,tzahl);
		strcat(text,tzahl);
		strcat(text,"     ");
		hell = hellPtr->hell;
		if (hell>9999)  {
			hell -= 10000;
			strcat(text,"<");
		} else
			strcat(text," ");
		sprintf(tzahl,"%4.1f",(double)hell*0.01);  
		strcat(text,tzahl);
		strcat(text,"    ");
		switch (hellPtr->art) {
		case 1: strcat(text,"vis."); break;
		case 2: strcat(text,"foto"); break;
		default:
			if (hellPtr->art/32==0) strcat(text,"?   ");
			else {
				sprintf(tzahl,"?/%.2i",hellPtr->art/32+1);
				strcat(text,tzahl);
			}   
		}
		strcat(text,"   ");
		strcat(text,hellPtr->bemerkung);
		if (hellPtr->observers) {
			strcat(text,"  ");
			strcat(text,hellPtr->observers);
		}
		fl_addto_browser(obj, text);
		hellPtr = hellPtr->next;
	}
}

void Beob_Liste ()
{
	int    count_vis = 0;
	struct RHell *hellPtr;
	char   text[80];
  
	if (stern.hellZahl==0)
		return;
		
	hellPtr = hellFirst;
	while (hellPtr!=NULL) {
		if (hellPtr->art==1) count_vis++;
		hellPtr = hellPtr->next;
	}
	if (fd_beob_list==NULL) {
		fd_beob_list = create_form_beob_list();
		fl_set_object_label( fd_beob_list->LObs, LS(141) );
		fl_set_object_label( fd_beob_list->LTitle, LS(142) );
		fl_set_object_label( fd_beob_list->New, LS(143) );
		fl_set_object_label( fd_beob_list->Edit, LS(144) );
		fl_set_object_label( fd_beob_list->Delete, LS(145) );
		fl_set_browser_dblclick_callback(fd_beob_list->Liste, cb_Beob_Wahl,2);
	}
	fl_freeze_form(fd_beob_list->beob_list);
	sprintf(text,"%i",stern.hellZahl);
	fl_set_object_label(fd_beob_list->ZahlAlle,text);
	sprintf(text,"%i",count_vis);
	fl_set_object_label(fd_beob_list->ZahlVis,text);
	Beob_Liste_Create(fd_beob_list->Liste);
	fl_unfreeze_form(fd_beob_list->beob_list);
	sprintf(text,LS(140),stern.name);
/*  fl_set_form_title(fd_beob_list->beob_list,text); */
	if (fd_beob_list_wp.x>0) 
		fl_set_form_position(fd_beob_list->beob_list, fd_beob_list_wp.x,fd_beob_list_wp.y);
	fl_show_form( fd_beob_list->beob_list,
                 (fd_beob_list_wp.x>0) ? FL_PLACE_GEOMETRY : FL_PLACE_SIZE,
                 FL_FULLBORDER,
                 text );
	beob_neu_work_hellPtr = NULL;
}

/****************************************************************************/
/*  Beobachtungseingabe                                                     */
/****************************************************************************/
  
void Beob_Edit (struct RHell *hellPtr)
{ 
	char str[30];

	if (fd_beob_neu==NULL) 
	{
		fd_beob_neu = create_form_beob_neu();
		fl_set_object_label( fd_beob_neu->LDate, LS(151) );
		fl_set_object_label( fd_beob_neu->LBright, LS(152) );
		fl_set_object_label( fd_beob_neu->LInfo, LS(153) );
		fl_set_object_label( fd_beob_neu->LComment, LS(154) );
		fl_set_object_label( fd_beob_neu->LMode, LS(155) );
		fl_set_object_label( fd_beob_neu->LObs, LS(156) );
		fl_set_object_label( fd_beob_neu->Cancel, LS_Cancel );
		fl_set_object_label( fd_beob_neu->OK, LS_OK );
		fl_set_object_shortcutkey( fd_beob_neu->OK, XK_Return );
	}

	beob_neu_work_hellPtr = hellPtr;

	if (hellPtr==NULL) 
	{
		GetDateTimeInputStr(str);
		fl_set_focus_object(fd_beob_neu->beob_neu,fd_beob_neu->Datum);
	} 
	else 
	{    
		fl_deactivate_object(fd_beob_neu->Datum);
		fl_set_focus_object(fd_beob_neu->beob_neu,fd_beob_neu->Helligkeit);	
		JulDat2Zeit(hellPtr->datum,str);
	}  
	fl_set_input(fd_beob_neu->Datum,str);

	if (hellPtr==NULL) 
	{
		fl_set_input(fd_beob_neu->Helligkeit,"");
		fl_set_input(fd_beob_neu->Observers,"");
	} 
	else 
	{
		if (hellPtr->hell<10000)
			sprintf(str,"%5.2f",hellPtr->hell*0.01);
		else
			sprintf(str,"<%5.2f",(hellPtr->hell-10000)*0.01);
		fl_set_input(fd_beob_neu->Helligkeit,str);  
		if (hellPtr->observers)
			fl_set_input( fd_beob_neu->Observers, hellPtr->observers );
		else
			fl_set_input( fd_beob_neu->Observers, "" );
	}
	
   fl_set_browser_fontsize(fd_beob_neu->Info,FL_SMALL_SIZE);
   fl_clear_browser(fd_beob_neu->Info);
	/*const char    INFO_CHR[30] = ":YIMUVWHLSAGJKZO"; declared above */
   fl_add_browser_line(fd_beob_neu->Info,": unsicher");
   fl_add_browser_line(fd_beob_neu->Info,"Y Activity (outburst, fading, flare, unusual)");
   fl_add_browser_line(fd_beob_neu->Info,"I Identification");
   fl_add_browser_line(fd_beob_neu->Info,"M Moon present");
   fl_add_browser_line(fd_beob_neu->Info,"U Clouds");
   fl_add_browser_line(fd_beob_neu->Info,"V Star near limit");
   fl_add_browser_line(fd_beob_neu->Info,"W Weather related problems");
   fl_add_browser_line(fd_beob_neu->Info,"H Haze, mist, fog");
   fl_add_browser_line(fd_beob_neu->Info,"L Low in sky, near horizon, trees, obstruction");
   fl_add_browser_line(fd_beob_neu->Info,"S Sequence problem");
   fl_add_browser_line(fd_beob_neu->Info,"A AAVSO Variable Star Atlas");
   fl_add_browser_line(fd_beob_neu->Info,"G GSC chart");
   fl_add_browser_line(fd_beob_neu->Info,"J Hipparcos chart");
   fl_add_browser_line(fd_beob_neu->Info,"K other non-AAVSO chart");
   fl_add_browser_line(fd_beob_neu->Info,"Z Possible errorneous, doubtful");
   fl_add_browser_line(fd_beob_neu->Info,"O Other (explain)");

	if (hellPtr==NULL) 
	{
		fl_set_input(fd_beob_neu->Bemerkung,"");
	} 
	else 
	{
		int i,ip;
		ip = 0;
    for (i=0; i<INFO_MAX; i++) 
      if (hellPtr->bemerkung[ip]==INFO_CHR[i]) {
        ip++;
        fl_select_browser_line(fd_beob_neu->Info,i+1);
      }   
    fl_set_input(fd_beob_neu->Bemerkung,hellPtr->bemerkung+ip);
  }  
    
  fl_clear_choice(fd_beob_neu->Art);
  fl_addto_choice(fd_beob_neu->Art,"visuell");
  fl_addto_choice(fd_beob_neu->Art,"fotogr.");
  fl_addto_choice(fd_beob_neu->Art,"unbekannt");

	if (hellPtr==NULL) 
	{
		fl_set_choice(fd_beob_neu->Art,1);
	} 
	else 
	{
		int s;
		switch (hellPtr->art & 3) 
		{
			case 0: s=3; break;
			case 1: s=1; break;
			case 2: s=2; break;
		} 
		fl_set_choice(fd_beob_neu->Art,s);
	}  
    
	fl_show_form(fd_beob_neu->beob_neu,FL_PLACE_MOUSE,FL_FULLBORDER,"New Observation");
}

void Beob_Neu_Helligkeit (struct RHell *hellPtr, char *hellStr)
{
	char *ptr;
	if (keyboardNumerikPoint) 
	{
		ptr = strchr(hellStr,',');
		if (ptr!=NULL)
			*ptr = '.';
	}	
	ptr = hellStr;
	while ((*ptr!='\0') && (*ptr==' ')) ptr++;
	if (*ptr=='<') 
	{
		hellPtr->hell = (int)(atof(ptr+1)*100+0.5);
		if (hellPtr->hell<0) 
			hellPtr->hell = 0;
		hellPtr->hell += 10000;
	} 
	else 
	{
		hellPtr->hell = (int)(atof(ptr)*100+0.5);
	}
}

void cb_Beob_Edit(FL_OBJECT *ob, long data)
{ 
   char          str[256], *ptr;
   struct RHell *hellPtr;
   int           i;

   if (beob_neu_work_hellPtr!=NULL)
      fl_activate_object(fd_beob_neu->Datum);
   
   fl_hide_form(fd_beob_neu->beob_neu);

   switch (data) {
   case 1: /* OK */
      strncpy(str, fl_get_input(fd_beob_neu->Datum), 40);
      if (beob_neu_work_hellPtr==NULL) {
         hellPtr = HellNew();
         hellPtr->datum = StrDate2JulDat(str);
      } else
         hellPtr = beob_neu_work_hellPtr;  

   	strncpy(str, fl_get_input(fd_beob_neu->Helligkeit), 40);
		Beob_Neu_Helligkeit(hellPtr,str);
		    
      hellPtr->bemerkung[0] = '\0';
      for (i=0; i<INFO_MAX; i++) 
         if (fl_isselected_browser_line(fd_beob_neu->Info,i+1)) 
            strncat(hellPtr->bemerkung,INFO_CHR+i,1);
      strncpy(str, fl_get_input(fd_beob_neu->Bemerkung), StrLenBemerkung);
      if (keyboardNumerikPoint) {
			while ((ptr = strchr(str,','))!=NULL)
				*ptr = '.';
		}	
		if (str[0]!='\0')
      strcat(str," ");
      strcat(hellPtr->bemerkung,str);    

   	if (beob_neu_work_hellPtr!=NULL) 
         i = (hellPtr->art / 32)*32;
      else
         i = 0;  
      switch (fl_get_choice(fd_beob_neu->Art)) {
      case 1: hellPtr->art=1; break;
      case 2: hellPtr->art=2; break;
      case 3: hellPtr->art=0; break;
      default: hellPtr->art=1;
      }
      hellPtr->art += i;

		if (strlen(fl_get_input(fd_beob_neu->Observers))>0) {
			SetString( &hellPtr->observers, fl_get_input(fd_beob_neu->Observers), 0 );
		} else {
			DeleteString( &hellPtr->observers );
		}
		
   	if (beob_neu_work_hellPtr==NULL) 
         HellPtrAdd(hellPtr,0);
   
      Beob_Liste();
      break;
   case 2:	/* Observer Info */
      if (beob_neu_work_hellPtr==NULL) {
      	Observer_Edit( NULL );
      } else
         Observer_Edit( beob_neu_work_hellPtr->observers );
      break;
   }
}

void Beob_Loeschen (struct RHell *hellPtr, struct RHell *vorPtr)
{
	if (hellPtr==hellFirst)
		hellFirst = hellPtr->next;
	else 
		vorPtr->next = hellPtr->next;
	HellDelete(&hellPtr);
	stern.hellZahl--;
	flagNeueDaten = TRUE;
	Beob_Liste();
}

void cb_Beob_Wahl(FL_OBJECT *ob, long data)
{ 
	int i;
	struct RHell *hellPtr, *hellVor;

	switch (data) {
	case 1: /* Neu */
		Beob_Edit(NULL);
		break;
	case 2:
	case 3:	
		i = fl_get_browser(fd_beob_list->Liste);
		if (i==0) break; 
		hellPtr = hellFirst;
		hellVor = NULL;
		while (--i>0) 
		{
			hellVor = hellPtr;
			hellPtr = hellPtr->next;
		}  
		if (data==2) 
			Beob_Edit(hellPtr);
		else  
			Beob_Loeschen(hellPtr,hellVor);
		break;
	}
}

void Beob_Close ()
{
	if ((fd_beob_list!=NULL) && (fd_beob_list->beob_list->visible))
	{
		fd_beob_list_wp.x = fd_beob_list->beob_list->x;
		fd_beob_list_wp.y = fd_beob_list->beob_list->y;
		fl_hide_form(fd_beob_list->beob_list);
	}
}

void Script_Beob_Neu (char *arg)
{
	char str[80], dateStr[80];
	struct RHell *hellPtr;
	struct RDisk *lastDiskPtr = NULL;
	int beob_art;
	dateStr[0] = 0;	

	if (standardObserver[0])
	{
		beob_art = 0;
		printf("Beobachter: %s\n",standardObserver);
	} 
	else 
	{
		if (arg[0]=='\0')
			beob_art = 1;
		else 
		{
			beob_art = atoi(arg);
			if ((beob_art<0) || (beob_art>2)) beob_art = 1;
		}
		printf("\nArt der Beobachtungen: ");
		switch (beob_art) {
		case 0: printf("unbekannt"); break;
		case 1: printf("visuell"); break;
		case 2: printf("fotografisch"); break;
		}
	}
	
	switch (useDateMode) {
	case USEDATE_GESTERN:
		GetYesterdayStr(str);
		break;
	case USEDATE_ECHTZEIT:
		sprintf(str,"(Echtzeit)");
  		break;
	case USEDATE_DATUM:
	default:
		strcpy(str,useDateStr);
	}
	printf("\nStandard-Datum: %s fuer %s-Zone\n", str, GetDatZoneStr[JulDatZone] );
	  
	do {
		printf("Sternname: ");
		sec_gets_80(str);
		if (str[0]=='\0') break;

		if (str[0]=='*' && lastDiskPtr) 
		{
			diskLoad = lastDiskPtr;
		} 
		else 
		{
			diskLoad = diskFirst;
			while ((diskLoad!=NULL) && (strcmp(diskLoad->name,str)!=0))
				diskLoad = diskLoad->next;
		}
	
		if (diskLoad==NULL) 
		{
			printf("Stern nicht gefunden!\n");
		} 
		else 
		{
			Daten_Laden_Stern();
			printf( "Lade Stern: %s %s  [%s]\n", diskLoad->index, diskLoad->stb, 
			        LS(70+stern.gruppe) );
			lastDiskPtr = diskLoad;

			if (useDateMode!=USEDATE_ECHTZEIT) 
			{
  				printf("Datum: ");
				sec_gets_80(str);
  				if (str[0]=='*' && dateStr[0]!=0)
  					strcpy(str,dateStr);
  				hellPtr = HellNew();
  				if (strlen(str)<6) 
  				{
					char datum[20];
  					GetDateTimeInputStr(datum);
  					strcat(datum,str);
  					strcpy(str,datum);
  				}
  				strcpy(dateStr,str);	// letztes Datum merken
			} 
			else 
			{
				GetDateTimeInputStr(str);
				printf("Datum: %s\n",str);
			}
			hellPtr->datum = StrDate2JulDat(str);

			printf("Helligkeit: ");
			sec_gets_80(str);
  			Beob_Neu_Helligkeit(hellPtr,str);
  		
			printf("Bemerkung: ");
			sec_gets_80(str);
			strn0cpy(hellPtr->bemerkung,str,StrLenBemerkung);
			if (keyboardNumerikPoint) 
			{
				char *ptr;
				for (ptr=hellPtr->bemerkung; *ptr!='\0'; ptr++) 
				{
					if (*ptr==',') *ptr = '.'; 
				}	
			}
			hellPtr->art = beob_art;
						
			JulDat2Zeit(hellPtr->datum,str);
			printf( "%s[%s] : ", str, GetDatZoneStr[JulDatZone] );
			if (hellPtr->hell<10000) 
				printf("%5.2f",(float)hellPtr->hell*0.01);
			else 	printf("<%5.2f",(float)(hellPtr->hell-10000)*0.01);
			printf("  --> ok? ");
			sec_gets_80(str);
			if (str[0]!='n') 
			{
				if (standardObserver[0])
					SetString( &hellPtr->observers, standardObserver, 0 );
				HellPtrAdd(hellPtr,0);
				ca_Daten_Speichern();
				printf("%s %s gespeichert!\n",diskLoad->index,diskLoad->stb);
			}
		}	
		printf("\n");
	} while (beob_art>=0);	
}


/****************************************************************************/
/*  Observers                                                               */
/****************************************************************************/

char* observerNameSelection = NULL;

void Observer_Edit ( const char* obsNameSelect )
{ 
   struct RObserver *obsPtr = observerFirst, *obsSelect = NULL;
   if (obsNameSelect && strlen(obsNameSelect)>0)
      SetStrings( &observerNameSelection, obsNameSelect, " " );
   else
   	observerNameSelection = NULL;
   
	if (fd_observer==NULL) 
	{
		fd_observer = create_form_observer();
		fl_set_browser_dblclick_callback( fd_observer->List, cb_Observer, 2 );
		fl_set_object_label( fd_observer->LCountry, LS(121) );
		fl_set_object_label( fd_observer->LInstruments, LS(122) );
		fl_set_object_label( fd_observer->Close, LS_Cancel );
		fl_set_object_label( fd_observer->Apply, LS_Apply );
	}

	fl_set_browser_fontsize(fd_observer->List,FL_SMALL_SIZE);
	fl_clear_browser(fd_observer->List);
	while (obsPtr) 
	{
		int add = TRUE;
		if (observerNameSelection) 
		{
   		char checkCode[32];
   		int i;
   		for (i=0; obsPtr->code[i]!=0; i++)
   			checkCode[i] = obsPtr->code[i];
   		checkCode[i] = ' ';
   		checkCode[i+1] = 0;
   		if (strstr( observerNameSelection, checkCode )==NULL)
   			add = FALSE;
   	}
   	if (add) {
			fl_add_browser_line( fd_observer->List, obsPtr->code );
			if (obsNameSelect && !obsSelect)
				obsSelect = obsPtr;
		}
		obsPtr->inList = add;
      obsPtr = obsPtr->next;
   }

   if (obsSelect) 
	{
      fl_set_input( fd_observer->Code , obsSelect->code );
      fl_set_input( fd_observer->Name , obsSelect->name );
      fl_set_input( fd_observer->EMail, obsSelect->email );
      fl_set_input( fd_observer->Country, obsSelect->country );
      fl_set_input( fd_observer->Instruments, obsSelect->instruments );
   }
	else 
	{
      fl_set_input( fd_observer->Code , "" );
      fl_set_input( fd_observer->Name , "" );
      fl_set_input( fd_observer->EMail, "" );
      fl_set_input( fd_observer->Country, "" );
      fl_set_input( fd_observer->Instruments, "" );
   }

	if (obsNameSelect)
		fl_select_browser_line( fd_observer->List, 1 );
 
	fl_show_form( fd_observer->observer, FL_PLACE_MOUSE, FL_FULLBORDER, LS(120) );
}


struct RObserver* Observer_GetPtr()
{
   struct RObserver* obsPtr = NULL;
   int i = fl_get_browser(fd_observer->List);
   if (i>0) 
	{
      obsPtr = observerFirst;
      while (i>0 && obsPtr!=NULL) 
		{
      	if (obsPtr->inList)
      		i--;
      	if (i>0)
         	obsPtr = obsPtr->next;
      }
   }
   return obsPtr;
}


void cb_Observer(FL_OBJECT *ob, long data)
{
	struct RObserver* obsPtr = Observer_GetPtr();
   
   switch (data) {
   case 1:	/* OK */
   	DeleteString( &observerNameSelection );
   case 3:	/* Apply */
      if (obsPtr) {
         strn0cpy( obsPtr->code, (char*)fl_get_input(fd_observer->Code), sizeof(obsPtr->code) );
         strn0cpy( obsPtr->name, (char*)fl_get_input(fd_observer->Name), sizeof(obsPtr->name) );
         SetString( &obsPtr->email, fl_get_input(fd_observer->EMail), 0 );
         SetString( &obsPtr->country, fl_get_input(fd_observer->Country), 0 );
         SetString( &obsPtr->instruments, fl_get_input(fd_observer->Instruments), 0 );
         observerChange = TRUE;
      }
      if (data==1)
         fl_hide_form(fd_observer->observer);
      break;
   case 2:
      if (obsPtr) {
         fl_set_input( fd_observer->Code , obsPtr->code  );
         fl_set_input( fd_observer->Name , obsPtr->name  );
         fl_set_input( fd_observer->EMail, obsPtr->email );
	      fl_set_input( fd_observer->Country, obsPtr->country );
   	   fl_set_input( fd_observer->Instruments, obsPtr->instruments );
      }
      break;
   }
}


/****************************************************************************/
/*  Statistics                                                              */
/****************************************************************************/

void Beob_Statistics()
{
	int           distN;
	struct RHell *hellPtr;
	double        distSum, distMin=1e7, distMax=-1, lastJD;
	char          strDate[32];

	for (hellPtr = hellFirst, distN=0, lastJD=-1; hellPtr!=NULL; hellPtr = hellPtr->next) {
		if ((besDatumVon<hellPtr->datum) && (hellPtr->datum<besDatumBis) && BitTest(besArt,hellPtr->art)) {
			if (lastJD>0) {
				double dist = hellPtr->datum - lastJD;
				if (dist<0) {
					ZeitDatum(hellPtr->datum,strDate);
					fprintf(stderr, "Warning: doubtfull date at %s\n",strDate);
					dist = fabs(dist);
				}
				distN++;
				distSum += dist;
				if (dist<distMin)	distMin = dist;
				if (dist>distMax)	distMax = dist;
			}
			lastJD = hellPtr->datum;
		}
	}
	
	ZeitDatum( besDatumVon, strDate );
	fprintf(stderr, "Statistics for %s\n", stern.name );
	fprintf(stderr, "  observer-flags %i, dates %s", 
	                besArt, strDate );
	ZeitDatum( besDatumBis, strDate );
	fprintf(stderr, " - %s\n", strDate );
	fprintf(stderr, "Observations:     %i\n", (distN>0 ? distN+1 : 0) );
	if (distN>0)
	fprintf(stderr, "Average distance: %f days\n", distSum/(float)distN );
	fprintf(stderr, "Distance min= %f,  max= %f days\n", distMin,distMax );
	fprintf(stderr, "\n" );
}

