
#include "stdlib.h"
#include "stdio.h"
#include "libtl/libtl_string.h"
#include "vs_forms.h"
#include "vs_sub.h"
#include "vs_main.h"
#include "vs_beob.h"
#include "vs_sonne.h"
#include "vs_graph.h"
#include "vs_language.h"

void Daten_Text()
{
	char text[80], str[30];
	int i;
  	if (diskLoad==diskFirst)
	{
		Sonne_Liste(FALSE);
		return;
	}
#ifndef NO_FORMS
	Beob_Liste();
	RepaintGraph();

	sprintf(text,"VARSTARS: %s",stern.name);
	fl_set_form_title(fd_vs->vs,text);
	fl_freeze_form(fd_vs->vs);  

	fl_set_input(fd_vs->Name,stern.name);
	sprintf(text,"%5.2f",stern.hellMax*0.01);
	fl_set_input(fd_vs->HellVon,text);
	sprintf(text,"%5.2f",stern.hellMin*0.01);
	fl_set_input(fd_vs->HellBis,text);

	if (stern.periode<0)  
	{
		fl_show_object(fd_vs->LPhaseScale);
		fl_hide_object(fd_vs->PhaseAb);
		fl_hide_object(fd_vs->PhaseMin);
		fl_hide_object(fd_vs->PhaseAn);
		fl_set_input(fd_vs->Periode,"Nova");
		sprintf(text,"%8.4f",-stern.periode); 
		fl_set_input(fd_vs->PhaseMax,text);
	} 
	else 
	{
		fl_hide_object(fd_vs->LPhaseScale);
		fl_show_object(fd_vs->PhaseAb);
		fl_show_object(fd_vs->PhaseMin);
		fl_show_object(fd_vs->PhaseAn);
		sprintf(text,"%11.7f",stern.periode); 
		fl_set_input(fd_vs->Periode,text);
		sprintf(text,"%4.1f",stern.pmax*0.5); 
		fl_set_input(fd_vs->PhaseMax,text);
		sprintf(text,"%4.1f",stern.pab*0.5); 
		fl_set_input(fd_vs->PhaseAb,text);
		sprintf(text,"%4.1f",stern.pmin*0.5); 
		fl_set_input(fd_vs->PhaseMin,text);
		sprintf(text,"%4.1f",stern.pan*0.5); 
		fl_set_input(fd_vs->PhaseAn,text);
	}

	if (stern.periode!=0) 
	{
		ZeitDatum(stern.max_jd,str);
		sprintf(text,"%s %s",str,GetDatZoneStr[JulDatZone]);
		fl_set_input(fd_vs->MaxDatum,text);
		Spektrum(stern.spektralklasse,str);
		fl_set_input(fd_vs->Spektrum,str);
		if (stern.entf==0) 
			strcpy(text,"unbekannt");
		else 
			sprintf(text,"%8.1f",stern.entf);
		fl_set_input(fd_vs->Entfernung,text);
	}

	fl_set_input(fd_vs->Typ,stern.typ);
	fl_set_input(fd_vs->Ordnung,stern.designation);
	fl_set_input(fd_vs->Karte,stern.karte);
	fl_set_button(fd_vs->HTML,stern.HTML); 
	fl_set_button(fd_vs->Alert,stern.Alert); 

	fl_clear_choice(fd_vs->TypGruppe);
	for (i=0; i<STG__LAST; i++)
		fl_addto_choice( fd_vs->TypGruppe, LS(70+i) );
	fl_set_choice(fd_vs->TypGruppe, stern.gruppe+1 );

	fl_set_button(fd_vs->ImportDeltaT, (stern.importDeltaT>=0) );
	sprintf( text, "%g", stern.importDeltaT );
	fl_set_input(fd_vs->ImportDeltaTvalue, text );
	if (stern.importDeltaT>=0)
		fl_show_object(fd_vs->ImportDeltaTvalue);
	else
		fl_hide_object(fd_vs->ImportDeltaTvalue);
		
	fl_unfreeze_form(fd_vs->vs);  
	fl_raise_form(fd_vs->vs);
#endif
}

void cb_Daten (FL_OBJECT *ob, long data)
{
#ifndef NO_FORMS
	char input[128];
	switch (data) {
	case 0 : 
		strn0cpy(stern.name,(char*)fl_get_input(fd_vs->Name),StrLenName-1);
		break;
	case 1 : 
		strcpy(input,fl_get_input(fd_vs->HellVon));
		stern.hellMax = atoHell(input);
		break;
  	case 2:  
		strcpy(input,fl_get_input(fd_vs->HellBis));
		stern.hellMin = atoHell(input);
		break;
  	case 3: 
		strcpy(input,fl_get_input(fd_vs->Periode));
		stern.periode = atof(input);
		break;
  	case 4:
		strcpy(input,fl_get_input(fd_vs->PhaseMax));
		if (stern.periode<0) /* Nova */
			stern.periode = -atof(input);
		else
			stern.pmax = (int)(atof(input)*2);     
		break;
	case 5:
		strcpy(input,fl_get_input(fd_vs->PhaseAb));
		stern.pab = (int)(atof(input)*2);     
		break;
	case 6:
		strcpy(input,fl_get_input(fd_vs->PhaseMin));
		stern.pmin = (int)(atof(input)*2);     
		break;
	case 7:
		strcpy(input,fl_get_input(fd_vs->PhaseAn));
		stern.pan = (int)(atof(input)*2);     
		break;
	case 8:
		strcpy(input,fl_get_input(fd_vs->MaxDatum));
		if ((input[2]=='.') || (input[4]=='/'))
			stern.max_jd = Zeit2JulDat(input);
		else if (input[5]=='.')
			stern.max_jd = 2400000+atof(input);
		else 
			stern.max_jd = atof(input);
		if (strchr(input,'m')!=NULL)
			stern.max_jd -= (stern.pmax/2+stern.pab)*stern.periode*0.005;
		break;
  	case 9:
		strcpy(input,fl_get_input(fd_vs->Spektrum));
  		stern.spektralklasse = GetSpektrumNr(input);
		break;
	case 10:      
		strcpy(input,fl_get_input(fd_vs->Entfernung));
		stern.entf = atof(input);
		if (stern.entf<0) 
			stern.entf=0;
		if (input[strlen(input)-1]=='p')
			stern.entf *= 3.2616;
		break;
  	case 11:
		strn0cpy(stern.typ,(char*)fl_get_input(fd_vs->Typ),StrLenTyp-1);
		break;
  	case 12:
		strn0cpy(stern.designation,(char*)fl_get_input(fd_vs->Ordnung),StrLenName-1);
		break;
  	case 13:
		strn0cpy(stern.karte,(char*)fl_get_input(fd_vs->Karte),StrLenKarte-1);
		break;
  	case 14:
		stern.HTML = fl_get_button(fd_vs->HTML); 
		break;   
	case 15:
		if (fl_get_button(fd_vs->ImportDeltaT)) 
		{
			stern.importDeltaT = importDeltaT;
			sprintf( input, "%f", stern.importDeltaT );
			fl_set_input( fd_vs->ImportDeltaTvalue, input );
			fl_show_object( fd_vs->ImportDeltaTvalue );
		} else {
			fl_hide_object( fd_vs->ImportDeltaTvalue );
			stern.importDeltaT = -1;
		}
  		break;
	case 16:
	  	strcpy( input, fl_get_input( fd_vs->ImportDeltaTvalue) );
		stern.importDeltaT = atof(input);
		break;
	case 17:
		stern.gruppe = fl_get_choice( fd_vs->TypGruppe ) -1;
		break;
	case 18:
		stern.Alert = fl_get_button(fd_vs->Alert); 
		break;
	}

	if ((stern.pmin<0) || (stern.pmin>199)) stern.pmin=1;
	stern.pan = stern.pmax+stern.pab+stern.pmin;
	if (stern.pan>200) stern.pan=0;
	else stern.pan=200-stern.pan;
#endif

	flagNeueDaten = TRUE;
	Daten_Text();
}

